/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 1)
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern16 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  return pattern41 (x3); /* [-1, 0] */
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern53 (x1, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern53 (x1, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern53 (x1, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern53 (x1, 
E_TImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern61 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern61 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  return pattern62 (x1); /* [-1, 1] */
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x8;
      return 0;

    case ROTATE:
      if (GET_MODE (x8) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!nonimmediate_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x8, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode)
          || !contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      return 1;

    case LSHIFTRT:
      res = pattern92 (x5);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case ASHIFT:
      res = pattern92 (x5);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern117 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1)
      || !setmem_operand (operands[2], i3)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x2, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1, machine_mode i1, int i2, rtx_code i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || XVECLEN (x1, 0) != i4
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LABEL_REF)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  return pattern170 (); /* [-1, 1] */
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_CCUmode))
        return -1;
      return 0;

    case SUBREG:
    case MEM:
      operands[1] = x2;
      if (!s_operand (operands[1], E_QImode))
        return -1;
      res = pattern71 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case SUBREG:
        case MEM:
          operands[3] = x7;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SCRATCH)
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x7) != E_BLKmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case SCRATCH:
              return 2;

            case REG:
            case SUBREG:
              operands[3] = x5;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern231 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern250 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (SUBREG_BYTE (x7))
    {
    case 0:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          return pattern257 (x2, 
E_TImode, 
E_DImode); /* [-1, 0] */

        case E_DImode:
          if (pattern257 (x2, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x7) != E_SImode
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode)
          || !register_operand (operands[3], E_TImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern284 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !addv_const_operand (operands[2], i2)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern291 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 1338 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 926; /* popcountv16qi2_vxe */
      if (!
#line 1346 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
        return -1;
      return 930; /* popcountv16qi2_vx */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1338 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 927; /* popcountv8hi2_vxe */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1338 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 928; /* popcountv4si2_vxe */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1338 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 929; /* popcountv2di2_vxe */

    case E_DImode:
      if (pattern104 (x2, pnum_clobbers, 
E_DImode) != 0
          || !(
#line 12113 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 792 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 2637; /* *popcountdi_z196 */

    case E_SImode:
      if (pattern104 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 12113 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2638; /* *popcountsi_z196 */

    case E_HImode:
      if (pattern104 (x2, pnum_clobbers, 
E_HImode) != 0
          || !
#line 12113 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2639; /* *popcounthi_z196 */

    case E_QImode:
      if (pattern104 (x2, pnum_clobbers, 
E_QImode) != 0
          || !
#line 12113 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2640; /* *popcountqi_z196 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1171; /* vec_widen_smult_even_v1qi */

    case 1:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1172; /* vec_widen_smult_even_v2qi */

    case 2:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1173; /* vec_widen_smult_even_v4qi */

    case 3:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1174; /* vec_widen_smult_even_v8qi */

    case 4:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1175; /* vec_widen_smult_even_v16qi */

    case 5:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1176; /* vec_widen_smult_even_v1hi */

    case 6:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1177; /* vec_widen_smult_even_v2hi */

    case 7:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1178; /* vec_widen_smult_even_v4hi */

    case 8:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1179; /* vec_widen_smult_even_v8hi */

    case 9:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1180; /* vec_widen_smult_even_v1si */

    case 10:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1181; /* vec_widen_smult_even_v2si */

    case 11:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1182; /* vec_widen_smult_even_v4si */

    case 12:
      if (!
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1183; /* vec_widen_smult_even_v1di */

    case 13:
      if (!(
#line 1717 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1184; /* vec_widen_smult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case AND:
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != NOT)
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern221 (x2, 
E_V16QImode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 46; /* vselv16qi */

                case E_V8HImode:
                  if (pattern221 (x2, 
E_V8HImode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 47; /* vselv8hi */

                case E_V4SImode:
                  if (pattern221 (x2, 
E_V4SImode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 48; /* vselv4si */

                case E_V2DImode:
                  if (pattern221 (x2, 
E_V2DImode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 49; /* vselv2di */

                case E_V1TImode:
                  if (pattern221 (x2, 
E_V1TImode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 50; /* vselv1ti */

                case E_V1DFmode:
                  if (pattern221 (x2, 
E_V1DFmode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 51; /* vselv1df */

                case E_V2DFmode:
                  if (pattern221 (x2, 
E_V2DFmode) != 0
                      || !
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 52; /* vselv2df */

                case E_V1SFmode:
                  if (pattern221 (x2, 
E_V1SFmode) != 0
                      || !(
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 53; /* vselv1sf */

                case E_V2SFmode:
                  if (pattern221 (x2, 
E_V2SFmode) != 0
                      || !(
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 54; /* vselv2sf */

                case E_V4SFmode:
                  if (pattern221 (x2, 
E_V4SFmode) != 0
                      || !(
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 55; /* vselv4sf */

                case E_V1TFmode:
                  if (pattern221 (x2, 
E_V1TFmode) != 0
                      || !(
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 56; /* vselv1tf */

                case E_TFmode:
                  if (pattern221 (x2, 
E_TFmode) != 0
                      || !(
#line 529 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 57; /* vseltf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x6;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern8 (x2, 
E_V1QImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1576; /* *vevalv1qi_iorand */

                case E_V2QImode:
                  if (pattern8 (x2, 
E_V2QImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1585; /* *vevalv2qi_iorand */

                case E_V4QImode:
                  if (pattern8 (x2, 
E_V4QImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1594; /* *vevalv4qi_iorand */

                case E_V8QImode:
                  if (pattern8 (x2, 
E_V8QImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1603; /* *vevalv8qi_iorand */

                case E_V16QImode:
                  if (pattern8 (x2, 
E_V16QImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1612; /* *vevalv16qi_iorand */

                case E_V1HImode:
                  if (pattern8 (x2, 
E_V1HImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1621; /* *vevalv1hi_iorand */

                case E_V2HImode:
                  if (pattern8 (x2, 
E_V2HImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1630; /* *vevalv2hi_iorand */

                case E_V4HImode:
                  if (pattern8 (x2, 
E_V4HImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1639; /* *vevalv4hi_iorand */

                case E_V8HImode:
                  if (pattern8 (x2, 
E_V8HImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1648; /* *vevalv8hi_iorand */

                case E_V1SImode:
                  if (pattern8 (x2, 
E_V1SImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1657; /* *vevalv1si_iorand */

                case E_V2SImode:
                  if (pattern8 (x2, 
E_V2SImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1666; /* *vevalv2si_iorand */

                case E_V4SImode:
                  if (pattern8 (x2, 
E_V4SImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1675; /* *vevalv4si_iorand */

                case E_V1DImode:
                  if (pattern8 (x2, 
E_V1DImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1684; /* *vevalv1di_iorand */

                case E_V2DImode:
                  if (pattern8 (x2, 
E_V2DImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1693; /* *vevalv2di_iorand */

                case E_V1TImode:
                  if (pattern8 (x2, 
E_V1TImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1702; /* *vevalv1ti_iorand */

                case E_TImode:
                  if (pattern8 (x2, 
E_TImode) != 0
                      || !
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1711; /* *vevalti_iorand */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 2);
              operands[5] = x10;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern243 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 4345 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1926; /* *risbgn_ior_and_sr_zedi */
                  if (pnum_clobbers == NULL
                      || !
#line 4345 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1927; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern243 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4345 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1928; /* *risbgn_ior_and_sr_zesi */
                  if (pnum_clobbers == NULL
                      || !
#line 4345 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1929; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern200 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1954; /* *insvdi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !(
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1955; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern200 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return 1956; /* *insvsi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1957; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern201 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4549 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1960; /* *insvdi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !(
#line 4549 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1961; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern201 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4549 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return 1962; /* *insvsi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !
#line 4549 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1963; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern202 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4564 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1964; /* *risbgn_di_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !(
#line 4564 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1965; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern202 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4564 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return 1966; /* *risbgn_si_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !
#line 4564 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1967; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  res = recog_21 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (pnum_clobbers == NULL)
                return -1;
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern189 (x2, 
E_DImode) != 0
                      || !(
#line 4678 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1974; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern189 (x2, 
E_SImode) != 0
                      || !
#line 4678 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1976; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != AND)
        return -1;
      x11 = XEXP (x4, 0);
      operands[3] = x11;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern184 (x2, 
E_V16QImode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 58; /* *vselv16qi_swapped */

        case E_V8HImode:
          if (pattern184 (x2, 
E_V8HImode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 59; /* *vselv8hi_swapped */

        case E_V4SImode:
          if (pattern184 (x2, 
E_V4SImode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 60; /* *vselv4si_swapped */

        case E_V2DImode:
          if (pattern184 (x2, 
E_V2DImode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 61; /* *vselv2di_swapped */

        case E_V1TImode:
          if (pattern184 (x2, 
E_V1TImode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 62; /* *vselv1ti_swapped */

        case E_V1DFmode:
          if (pattern184 (x2, 
E_V1DFmode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 63; /* *vselv1df_swapped */

        case E_V2DFmode:
          if (pattern184 (x2, 
E_V2DFmode) != 0
              || !
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 64; /* *vselv2df_swapped */

        case E_V1SFmode:
          if (pattern184 (x2, 
E_V1SFmode) != 0
              || !(
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 65; /* *vselv1sf_swapped */

        case E_V2SFmode:
          if (pattern184 (x2, 
E_V2SFmode) != 0
              || !(
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 80 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 66; /* *vselv2sf_swapped */

        case E_V4SFmode:
          if (pattern184 (x2, 
E_V4SFmode) != 0
              || !(
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 67; /* *vselv4sf_swapped */

        case E_V1TFmode:
          if (pattern184 (x2, 
E_V1TFmode) != 0
              || !(
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 81 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 68; /* *vselv1tf_swapped */

        case E_TFmode:
          if (pattern184 (x2, 
E_TFmode) != 0
              || !(
#line 540 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 69; /* *vseltf_swapped */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern60 (x2, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode)
          || !
#line 4693 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      *pnum_clobbers = 1;
      return 1978; /* *rosbg_di_rotl */

    case LSHIFTRT:
      switch (pattern63 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4708 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1980; /* *rosbg_di_srl_bitmask */

        case 1:
          if (!
#line 4708 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 1982; /* *rosbg_si_srl_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern63 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4728 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1984; /* *rosbg_di_sll_bitmask */

        case 1:
          if (!
#line 4728 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 1986; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 4854 "../../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 780 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2000; /* *insvdi_mem_reg */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !(
#line 4854 "../../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 780 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
        return -1;
      return 2001; /* *insvsi_mem_reg */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1501; /* extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1503; /* extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1505; /* extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1507; /* extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1509; /* extendv4hiv4si2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2670 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1511; /* vec_unpacks_hi_v16qi */

        case 1:
          if (!
#line 2681 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1512; /* vec_unpacks_lo_v16qi */

        case 2:
          if (!
#line 2719 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1515; /* vec_unpacks_hi_v8hi */

        case 3:
          if (!
#line 2729 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1516; /* vec_unpacks_lo_v8hi */

        case 4:
          if (!
#line 2765 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1519; /* vec_unpacks_hi_v4si */

        case 5:
          if (!
#line 2775 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1520; /* vec_unpacks_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case AND:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_46 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MULT:
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      res = recog_50 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      operands[1] = x2;
      if (address_operand (operands[1], E_QImode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && 
#line 2304 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return 1845; /* *la_64 */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && 
#line 2531 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT && legitimate_la_operand_p (operands[1])))
                return 1849; /* *la_31 */
              break;

            default:
              break;
            }
        }
      break;

    case PC:
      operands[0] = x2;
      if (address_operand (operands[0], E_VOIDmode)
          && 
#line 10375 "../../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK))
        return 2541; /* *indirect_jump */
      if (register_operand (operands[0], E_DImode)
          && (
#line 10394 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return 2542; /* indirect_jump_via_thunkdi_z10 */
      if (register_operand (operands[0], E_SImode)
          && (
#line 10394 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2543; /* indirect_jump_via_thunksi_z10 */
      if (pnum_clobbers != NULL)
        {
          if (register_operand (operands[0], E_DImode)
              && (
#line 10412 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2544; /* indirect_jump_via_thunkdi */
            }
          if (register_operand (operands[0], E_SImode)
              && (
#line 10412 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2545; /* indirect_jump_via_thunksi */
            }
        }
      if (nonimmediate_operand (operands[0], E_VOIDmode)
          && 
#line 10468 "../../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
        return 2550; /* *indirect2_jump */
      break;

    default:
      break;
    }
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case AND:
      return recog_52 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (pnum_clobbers == NULL
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 4
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_CCUmode)
              || !
#line 4204 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1915; /* *cmpint_sign */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (pattern88 (x2))
            {
            case 0:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && 
#line 4983 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2008; /* *extendsidi2 */
              if (general_operand (operands[1], E_HImode)
                  && 
#line 5028 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && TARGET_EXTIMM))
                return 2009; /* *extendhidi2_extimm */
              if (memory_operand (operands[1], E_HImode)
                  && 
#line 5042 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2010; /* *extendhidi2 */
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5085 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2013; /* *extendqidi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && (
#line 5096 "../../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2015; /* *extendqidi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !(
#line 5105 "../../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2017; /* *extendqidi2_short_displ */

            case 1:
              if (nonimmediate_operand (operands[1], E_HImode)
                  && 
#line 5054 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2011; /* *extendhisi2_extimm */
              if (!memory_operand (operands[1], E_HImode)
                  || !
#line 5069 "../../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM))
                return -1;
              return 2012; /* *extendhisi2 */

            case 2:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && 
#line 5085 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2014; /* *extendqisi2_extimm */
              if (memory_operand (operands[1], E_QImode)
                  && 
#line 5096 "../../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && TARGET_LONG_DISPLACEMENT))
                return 2016; /* *extendqisi2 */
              if (pnum_clobbers == NULL
                  || !s_operand (operands[1], E_QImode)
                  || !
#line 5105 "../../../gcc/config/s390/s390.md"
(!TARGET_EXTIMM && !TARGET_LONG_DISPLACEMENT))
                return -1;
              *pnum_clobbers = 1;
              return 2018; /* *extendqisi2_short_displ */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern88 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 5141 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2019; /* *zero_extendsidi2 */

            case E_HImode:
              if (nonimmediate_operand (operands[1], E_HImode))
                {
                  if ((
#line 5255 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2024; /* *zero_extendhidi2_z10 */
                  if ((
#line 5270 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2026; /* *zero_extendhidi2_extimm */
                }
              if (!memory_operand (operands[1], E_HImode)
                  || !(
#line 5281 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2030; /* *zero_extendhidi2 */

            case E_QImode:
              if (nonimmediate_operand (operands[1], E_QImode)
                  && (
#line 5270 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2028; /* *zero_extendqidi2_extimm */
              if (!memory_operand (operands[1], E_QImode)
                  || !(
#line 5281 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2032; /* *zero_extendqidi2 */

            default:
              return -1;
            }

        case 1:
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if (
#line 5255 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return 2025; /* *zero_extendhisi2_z10 */
              if (
#line 5270 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
                return 2027; /* *zero_extendhisi2_extimm */
            }
          if (memory_operand (operands[1], E_HImode)
              && 
#line 5281 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2031; /* *zero_extendhisi2 */
          if (pnum_clobbers == NULL
              || !s_operand (operands[1], E_HImode)
              || !
#line 5290 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2034; /* *zero_extendhisi2_31 */

        case 2:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 5270 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return 2029; /* *zero_extendqisi2_extimm */
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5281 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2033; /* *zero_extendqisi2 */
          if (!
#line 5302 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2035; /* *zero_extendqisi2_31 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          switch (pattern175 (x2))
            {
            case 0:
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6105 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2191; /* *adddi3_sign */
                }
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6391 "../../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              *pnum_clobbers = 1;
              return 2215; /* *adddi3_sign */

            case 1:
              *pnum_clobbers = 1;
              return 2196; /* *addsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 6144 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2194; /* *adddi3_zero */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (pattern158 (x2))
            {
            case 0:
              if (
#line 6156 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                {
                  *pnum_clobbers = 1;
                  return 2195; /* *adddi3_31z */
                }
              if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2197; /* *adddi3 */

            case 1:
              *pnum_clobbers = 1;
              return 2198; /* *addsi3 */

            default:
              return -1;
            }

        case PLUS:
          x6 = XEXP (x4, 0);
          operands[3] = x6;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern209 (x2, 
E_DImode) != 0
                  || !
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2290; /* *adddi3_alc */

            case E_SImode:
              if (pattern209 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2291; /* *addsi3_alc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern210 (x2, 
E_DImode) != 0)
                    return -1;
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 6651 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2239; /* *subdi3_sign */
                    }
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 6877 "../../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2259; /* *subdi3_sign */

                case E_SImode:
                  if (pattern210 (x2, 
E_SImode) != 0
                      || !memory_operand (operands[2], E_HImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2244; /* *subsi3_sign */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!general_operand (operands[2], E_SImode)
                  || !
#line 6691 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2242; /* *subdi3_zero */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern85 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 6703 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    {
                      *pnum_clobbers = 1;
                      return 2243; /* *subdi3_31z */
                    }
                  if (!
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2245; /* *subdi3 */

                case E_SImode:
                  if (pattern85 (x2, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 2246; /* *subsi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          x7 = XEXP (x2, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern211 (x2, 
E_DImode) != 0
                  || !
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2294; /* *subdi3_slb */

            case E_SImode:
              if (pattern211 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2295; /* *subsi3_slb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (pattern175 (x2))
                {
                case 0:
                  if (general_operand (operands[2], E_SImode)
                      && 
#line 7397 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2307; /* *muldi3_sign */
                  if (!memory_operand (operands[2], E_HImode)
                      || !
#line 7449 "../../../gcc/config/s390/s390.md"
(TARGET_Z14))
                    return -1;
                  return 2311; /* *muldi3_sign */

                case 1:
                  return 2312; /* *mulsi3_sign */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x6 = XEXP (x4, 0);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!nonimmediate_operand (operands[2], E_SImode)
                  || !
#line 7505 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 2314; /* mulsidi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern174 (x2, 
E_DImode) != 0
                  || !
#line 7409 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2308; /* *muldi3 */

            case E_SImode:
              if (pattern174 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2313; /* *mulsi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern113 (x2, 
E_SImode, 
E_DImode) != 0
              || !
#line 779 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2318; /* umulsidi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1294; /* *vec_cmpeqv1qiv1qi_nocc */
          break;

        case 1:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1297; /* *vec_cmpeqv2qiv2qi_nocc */
          break;

        case 2:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1300; /* *vec_cmpeqv4qiv4qi_nocc */
          break;

        case 3:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1303; /* *vec_cmpeqv8qiv8qi_nocc */
          break;

        case 4:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1306; /* *vec_cmpeqv16qiv16qi_nocc */
          break;

        case 5:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1309; /* *vec_cmpeqv1hiv1hi_nocc */
          break;

        case 6:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1312; /* *vec_cmpeqv2hiv2hi_nocc */
          break;

        case 7:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1315; /* *vec_cmpeqv4hiv4hi_nocc */
          break;

        case 8:
          if (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1318; /* *vec_cmpeqv8hiv8hi_nocc */
          break;

        case 9:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1SImode)
                  && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1321; /* *vec_cmpeqv1siv1si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1SFmode)
                  && (
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1348; /* *vec_cmpeqv1sf_quiet_nocc */
            }
          break;

        case 10:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1324; /* *vec_cmpeqv2siv2si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2SFmode)
                  && (
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1349; /* *vec_cmpeqv2sf_quiet_nocc */
            }
          break;

        case 11:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1327; /* *vec_cmpeqv4siv4si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V4SFmode)
                  && (
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1350; /* *vec_cmpeqv4sf_quiet_nocc */
            }
          break;

        case 12:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1330; /* *vec_cmpeqv1div1di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1DFmode)
                  && 
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1351; /* *vec_cmpeqv1df_quiet_nocc */
            }
          break;

        case 13:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2DImode)
                  && 
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1333; /* *vec_cmpeqv2div2di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2DFmode)
                  && 
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1352; /* *vec_cmpeqv2df_quiet_nocc */
            }
          break;

        case 14:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1TImode)
                  && (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1336; /* *vec_cmpeqv1tiv1ti_nocc */
            }
          operands[0] = x3;
          switch (pattern110 (x2))
            {
            case 0:
              if (
#line 2128 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1342; /* *vec_cmpeqv1tiv1ti_nocc_emu */
              break;

            case 1:
              if ((
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1353; /* *vec_cmpeqv1tf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        case 15:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_TImode)
                  && (
#line 2120 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1339; /* *vec_cmpeqtiti_nocc */
            }
          operands[0] = x3;
          switch (pattern111 (x2))
            {
            case 0:
              if (
#line 2128 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1343; /* *vec_cmpeqtiti_nocc_emu */
              break;

            case 1:
              if ((
#line 2222 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1354; /* *vec_cmpeqtf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case GT:
      res = recog_35 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
      res = recog_36 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7280 "../../../gcc/config/s390/s390.md"
(TARGET_Z13) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2303; /* *cstoreccdi_z13 */

        case 1:
          if (!
#line 7280 "../../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2304; /* *cstoreccsi_z13 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (pattern253 (x10, 
ZERO_EXTEND, 
PLUS) != 0)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[1])
              || !
#line 6119 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2192; /* *adddi3_zero_cc */

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          if (!scratch_operand (operands[0], E_DImode)
              || !
#line 6132 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          return 2193; /* *adddi3_zero_cconly */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_81 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && scratch_operand (operands[0], E_DImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 6258 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2201; /* *adddi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 6298 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2205; /* *adddi3_carry2_cconly */
                }
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && scratch_operand (operands[0], E_SImode))
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 6258 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2202; /* *addsi3_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 6298 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2206; /* *addsi3_carry2_cconly */
                }
              break;

            case E_TFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_TFmode) == 0
                  && (
#line 6519 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2232; /* *addtf3_cconly */
              break;

            case E_FPRX2mode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_FPRX2mode) == 0
                  && (
#line 6519 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2233; /* *addfprx23_cconly */
              break;

            case E_DFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_DFmode) == 0
                  && 
#line 6519 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2234; /* *adddf3_cconly */
              break;

            case E_SFmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_SFmode) == 0
                  && 
#line 6519 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return 2235; /* *addsf3_cconly */
              break;

            case E_TDmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_TDmode) == 0
                  && (
#line 6519 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2236; /* *addtd3_cconly */
              break;

            case E_DDmode:
              x6 = XEXP (x3, 1);
              if (pattern225 (x6, 
E_DDmode) == 0
                  && (
#line 6519 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return 2237; /* *adddd3_cconly */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x10) != E_DImode)
                return -1;
              if (general_operand (operands[2], E_DImode)
                  && (
#line 6316 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2207; /* *adddi3_cc */
              if (!const_int_operand (operands[2], E_DImode)
                  || !(
#line 6372 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2213; /* *adddi3_imm_cc */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x10) != E_SImode)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6316 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return 2208; /* *addsi3_cc */
              if (!const_int_operand (operands[2], E_SImode)
                  || !
#line 6372 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)
   && (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'K', "K")
       || (CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'O', "Os")
           /* Avoid INT32_MIN on 32 bit.  */
           && (!TARGET_ZARCH || INTVAL (operands[2]) != -0x7fffffff - 1)))))
                return -1;
              return 2214; /* *addsi3_imm_cc */

            default:
              return -1;
            }

        case CLOBBER:
          switch (pattern146 (x1))
            {
            case 0:
              if (!(
#line 6338 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2209; /* *adddi3_cconly */

            case 1:
              if (!
#line 6338 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                return -1;
              return 2210; /* *addsi3_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x6, 0);
      if (GET_CODE (x15) != PLUS)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x9, 0);
      operands[0] = x11;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x17 = XEXP (x8, 0);
          operands[2] = x17;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern283 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6439 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2216; /* *addvdi3_ccoverflow */

            case E_DImode:
              if (pattern283 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6439 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2217; /* *addvsi3_ccoverflow */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x8;
          x18 = XEXP (x15, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_TImode:
              if (pattern284 (x1, 
E_DImode, 
E_TImode) != 0
                  || !(
#line 6462 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2218; /* *addvdi3_ccoverflow_const */

            case E_DImode:
              if (pattern284 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 6462 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCOmode)))
                return -1;
              return 2219; /* *addvsi3_ccoverflow_const */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          res = recog_82 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CLOBBER:
          x11 = XEXP (x9, 0);
          operands[0] = x11;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern237 (x5, 
E_DImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && (
#line 7034 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2282; /* *adddi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && (
#line 7068 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2286; /* *adddi3_alc_carry2_cconly */
                }
              break;

            case E_SImode:
              if (pattern237 (x5, 
E_SImode) == 0)
                {
                  x6 = XEXP (x3, 1);
                  if (rtx_equal_p (x6, operands[1])
                      && 
#line 7034 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2283; /* *addsi3_alc_carry1_cconly */
                  if (rtx_equal_p (x6, operands[2])
                      && 
#line 7068 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                    return 2287; /* *addsi3_alc_carry2_cconly */
                }
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_CODE (x9) != SET
          || pattern213 (x9) != 0)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (pattern277 (x1, 
E_DImode) != 0
              || !(
#line 7084 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2288; /* *adddi3_alc_cc */

        case E_SImode:
          if (pattern277 (x1, 
E_SImode) != 0
              || !
#line 7084 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          return 2289; /* *addsi3_alc_cc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_108 (x1, insn, pnum_clobbers);

    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != EQ)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !(
#line 9995 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2531; /* *load_and_trapdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 9995 "../../../gcc/config/s390/s390.md"
(TARGET_ZEC12))
            return -1;
          return 2532; /* *load_and_trapsi */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      x6 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x6, 1);
      operands[0] = x9;
      x12 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x12))
        {
        case CONST_INT:
          if (XWINT (x12, 0) != 0L)
            return -1;
          if (larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10436 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2546; /* indirect_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10436 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2547; /* indirect_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[2] = x12;
          if (register_operand (operands[2], E_DImode)
              && larl_operand (operands[1], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10452 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2548; /* indirect_jump_via_inlinethunkdi */
          if (!register_operand (operands[2], E_SImode)
              || !larl_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10452 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2549; /* indirect_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (register_operand (operands[2], E_VOIDmode))
        {
          if (bras_sym_operand (operands[0], E_VOIDmode))
            {
              if (
#line 10862 "../../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)
   && TARGET_SMALL_EXEC
   && GET_MODE (operands[2]) == Pmode))
                return 2567; /* *bras */
              if (
#line 10874 "../../../gcc/config/s390/s390.md"
(!SIBLING_CALL_P (insn)

   && GET_MODE (operands[2]) == Pmode))
                return 2568; /* *brasl */
            }
          if (address_operand (operands[0], E_VOIDmode)
              && 
#line 10887 "../../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[2]) == Pmode))
            return 2569; /* *basr */
        }
      if (register_operand (operands[2], E_DImode)
          && register_operand (operands[0], E_DImode))
        {
          if ((
#line 10910 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2570; /* *basr_via_thunkdi_z10 */
          if (pnum_clobbers != NULL
              && (
#line 10931 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 2572; /* *basr_via_thunkdi */
            }
        }
      if (!register_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      if ((
#line 10910 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return 2571; /* *basr_via_thunksi_z10 */
      if (pnum_clobbers == NULL
          || !(
#line 10931 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 2573; /* *basr_via_thunksi */

    case RETURN:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != USE)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          if ((
#line 11841 "../../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2619; /* *returndi */
          if (pnum_clobbers == NULL
              || !(
#line 11869 "../../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          if ((
#line 11841 "../../../gcc/config/s390/s390.md"
(TARGET_CPU_Z10 || !TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return 2620; /* *returnsi */
          if (pnum_clobbers == NULL
              || !(
#line 11869 "../../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (load_multiple_operation (operands[0], E_VOIDmode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && s_operand (operands[2], E_DImode)
                  && 
#line 3239 "../../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
                return 1874; /* *load_multiple_di */
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && s_operand (operands[2], E_SImode)
                  && 
#line 3252 "../../../gcc/config/s390/s390.md"
(reload_completed))
                return 1875; /* *load_multiple_si */
              break;

            default:
              break;
            }
        }
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !
#line 3331 "../../../gcc/config/s390/s390.md"
(reload_completed && TARGET_ZARCH))
            return -1;
          return 1876; /* *store_multiple_di */

        case E_SImode:
          if (!s_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 3345 "../../../gcc/config/s390/s390.md"
(reload_completed))
            return -1;
          return 1877; /* *store_multiple_si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 18
          || !execute_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      if (larl_operand (operands[3], E_SImode)
          && 
#line 3364 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return 1878; /* *execute_rl */
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 3376 "../../../gcc/config/s390/s390.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[1])) <= UNITS_PER_WORD))
        return -1;
      return 1879; /* *execute */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern101 (x2))
    {
    case 0:
      if (all_ones_operand (operands[1], E_V1QImode)
          && const0_operand (operands[2], E_V1QImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_94 (insn, operands);
      if (!const0_operand (operands[1], E_V1QImode)
          || !all_ones_operand (operands[2], E_V1QImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_113 (insn, operands);

    case 1:
      if (all_ones_operand (operands[1], E_V2QImode)
          && const0_operand (operands[2], E_V2QImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_95 (insn, operands);
      if (!const0_operand (operands[1], E_V2QImode)
          || !all_ones_operand (operands[2], E_V2QImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_114 (insn, operands);

    case 2:
      if (all_ones_operand (operands[1], E_V4QImode)
          && const0_operand (operands[2], E_V4QImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_96 (insn, operands);
      if (!const0_operand (operands[1], E_V4QImode)
          || !all_ones_operand (operands[2], E_V4QImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_115 (insn, operands);

    case 3:
      if (all_ones_operand (operands[1], E_V8QImode)
          && const0_operand (operands[2], E_V8QImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_97 (insn, operands);
      if (!const0_operand (operands[1], E_V8QImode)
          || !all_ones_operand (operands[2], E_V8QImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_116 (insn, operands);

    case 4:
      if (all_ones_operand (operands[1], E_V16QImode)
          && const0_operand (operands[2], E_V16QImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_98 (insn, operands);
      if (!const0_operand (operands[1], E_V16QImode)
          || !all_ones_operand (operands[2], E_V16QImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_117 (insn, operands);

    case 5:
      if (all_ones_operand (operands[1], E_V1HImode)
          && const0_operand (operands[2], E_V1HImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_99 (insn, operands);
      if (!const0_operand (operands[1], E_V1HImode)
          || !all_ones_operand (operands[2], E_V1HImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_118 (insn, operands);

    case 6:
      if (all_ones_operand (operands[1], E_V2HImode)
          && const0_operand (operands[2], E_V2HImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_100 (insn, operands);
      if (!const0_operand (operands[1], E_V2HImode)
          || !all_ones_operand (operands[2], E_V2HImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_119 (insn, operands);

    case 7:
      if (all_ones_operand (operands[1], E_V4HImode)
          && const0_operand (operands[2], E_V4HImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_101 (insn, operands);
      if (!const0_operand (operands[1], E_V4HImode)
          || !all_ones_operand (operands[2], E_V4HImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_120 (insn, operands);

    case 8:
      if (all_ones_operand (operands[1], E_V8HImode)
          && const0_operand (operands[2], E_V8HImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_102 (insn, operands);
      if (!const0_operand (operands[1], E_V8HImode)
          || !all_ones_operand (operands[2], E_V8HImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_121 (insn, operands);

    case 9:
      if (all_ones_operand (operands[1], E_V1SImode)
          && const0_operand (operands[2], E_V1SImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_103 (insn, operands);
      if (!const0_operand (operands[1], E_V1SImode)
          || !all_ones_operand (operands[2], E_V1SImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_122 (insn, operands);

    case 10:
      if (all_ones_operand (operands[1], E_V2SImode)
          && const0_operand (operands[2], E_V2SImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_104 (insn, operands);
      if (!const0_operand (operands[1], E_V2SImode)
          || !all_ones_operand (operands[2], E_V2SImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_123 (insn, operands);

    case 11:
      if (all_ones_operand (operands[1], E_V4SImode)
          && const0_operand (operands[2], E_V4SImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_105 (insn, operands);
      if (!const0_operand (operands[1], E_V4SImode)
          || !all_ones_operand (operands[2], E_V4SImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_124 (insn, operands);

    case 12:
      if (all_ones_operand (operands[1], E_V1DImode)
          && const0_operand (operands[2], E_V1DImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_106 (insn, operands);
      if (!const0_operand (operands[1], E_V1DImode)
          || !all_ones_operand (operands[2], E_V1DImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_125 (insn, operands);

    case 13:
      if (all_ones_operand (operands[1], E_V2DImode)
          && const0_operand (operands[2], E_V2DImode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_107 (insn, operands);
      if (!const0_operand (operands[1], E_V2DImode)
          || !all_ones_operand (operands[2], E_V2DImode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_126 (insn, operands);

    case 14:
      if (all_ones_operand (operands[1], E_V1SFmode)
          && const0_operand (operands[2], E_V1SFmode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_108 (insn, operands);
      if (!const0_operand (operands[1], E_V1SFmode)
          || !all_ones_operand (operands[2], E_V1SFmode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_127 (insn, operands);

    case 15:
      if (all_ones_operand (operands[1], E_V2SFmode)
          && const0_operand (operands[2], E_V2SFmode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_109 (insn, operands);
      if (!const0_operand (operands[1], E_V2SFmode)
          || !all_ones_operand (operands[2], E_V2SFmode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_128 (insn, operands);

    case 16:
      if (all_ones_operand (operands[1], E_V4SFmode)
          && const0_operand (operands[2], E_V4SFmode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_110 (insn, operands);
      if (!const0_operand (operands[1], E_V4SFmode)
          || !all_ones_operand (operands[2], E_V4SFmode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_129 (insn, operands);

    case 17:
      if (all_ones_operand (operands[1], E_V1DFmode)
          && const0_operand (operands[2], E_V1DFmode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_111 (insn, operands);
      if (!const0_operand (operands[1], E_V1DFmode)
          || !all_ones_operand (operands[2], E_V1DFmode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_130 (insn, operands);

    case 18:
      if (all_ones_operand (operands[1], E_V2DFmode)
          && const0_operand (operands[2], E_V2DFmode)
          && 
#line 2526 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return gen_split_112 (insn, operands);
      if (!const0_operand (operands[1], E_V2DFmode)
          || !all_ones_operand (operands[2], E_V2DFmode)
          || !
#line 2540 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return NULL;
      return gen_split_131 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (nonimmediate_operand (operands[0], E_TFmode))
        {
          if (GET_CODE (x2) == SUBREG
              && known_eq (SUBREG_BYTE (x2), 0)
              && GET_MODE (x2) == E_TFmode)
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (general_operand (operands[1], E_FPRX2mode)
                  && 
#line 682 "../../../gcc/config/s390/vector.md"
(!(MEM_P (operands[0]) && MEM_VOLATILE_P (operands[0]))))
                return gen_split_37 (insn, operands);
            }
          operands[1] = x2;
          if (general_operand (operands[1], E_TFmode))
            {
              if ((
#line 2822 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 761 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_299 (insn, operands);
              if ((
#line 2838 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TFmode)
   && !s_operand (operands[1], TFmode)
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 761 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return gen_split_302 (insn, operands);
            }
        }
      operands[1] = x2;
      if (memory_operand (operands[1], E_TFmode)
          && register_operand (operands[0], E_TFmode))
        {
          if ((
#line 2854 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 761 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_305 (insn, operands);
          if ((
#line 2870 "../../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 761 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return gen_split_308 (insn, operands);
        }
      if (!register_operand (operands[1], E_TFmode)
          || !memory_operand (operands[0], E_TFmode)
          || !(
#line 2886 "../../../gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 761 "../../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return NULL;
      return gen_split_311 (insn, operands);

    case VEC_DUPLICATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 713 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_38 (insn, operands);

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 713 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_39 (insn, operands);

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 713 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_40 (insn, operands);

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 713 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_41 (insn, operands);

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 713 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_42 (insn, operands);

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 713 "../../../gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[1])))
            return NULL;
          return gen_split_43 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      if (pattern7 (x1) != 0
          || !(
#line 2024 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2026 "../../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_48 (insn, operands);

    case SMIN:
      if (pattern7 (x1) != 0
          || !(
#line 2060 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE) && 
#line 2062 "../../../gcc/config/s390/vector.md"
( 1)))
        return NULL;
      return gen_split_49 (insn, operands);

    case IF_THEN_ELSE:
      return split_3 (x1, insn);

    case AND:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_150 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_159 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_186 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_213 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_240 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_258 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_267 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_276 (insn, operands);

        case 16:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 17:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_151 (insn, operands);

        case 18:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_160 (insn, operands);

        case 19:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_169 (insn, operands);

        case 20:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_178 (insn, operands);

        case 21:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_187 (insn, operands);

        case 22:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 23:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_205 (insn, operands);

        case 24:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_214 (insn, operands);

        case 25:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_223 (insn, operands);

        case 26:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_232 (insn, operands);

        case 27:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_241 (insn, operands);

        case 28:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_250 (insn, operands);

        case 29:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_259 (insn, operands);

        case 30:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_268 (insn, operands);

        case 31:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_277 (insn, operands);

        case 32:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 33:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_152 (insn, operands);

        case 34:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_161 (insn, operands);

        case 35:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 36:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_179 (insn, operands);

        case 37:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_188 (insn, operands);

        case 38:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 39:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_206 (insn, operands);

        case 40:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_215 (insn, operands);

        case 41:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_224 (insn, operands);

        case 42:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_233 (insn, operands);

        case 43:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_242 (insn, operands);

        case 44:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_251 (insn, operands);

        case 45:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_260 (insn, operands);

        case 46:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_269 (insn, operands);

        case 47:
          if (!(
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      return split_4 (x1, insn);

    case XOR:
      return split_5 (x1, insn);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_VOIDmode))
        return NULL;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (!memory_operand (operands[1], E_VOIDmode)
          || !
#line 1502 "../../../gcc/config/s390/s390.md"
(reload_completed
   && s390_match_ccmode (insn, CCUmode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && GET_MODE_SIZE (GET_MODE (operands[0])) > 0))
        return NULL;
      return gen_split_285 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XVECEXP (x2, 0, 0);
      operands[1] = x6;
      switch (XINT (x2, 1))
        {
        case 30:
          switch (pattern80 (x2))
            {
            case 0:
              if (!
#line 2164 "../../../gcc/config/s390/s390.md"
( reload_completed))
                return NULL;
              return gen_split_290 (insn, operands);

            case 1:
              if (!(
#line 2171 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 2173 "../../../gcc/config/s390/s390.md"
( reload_completed)))
                return NULL;
              return gen_split_291 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          if (GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_VOIDmode)
              || !
#line 3785 "../../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_325 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_QImode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 5302 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5304 "../../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_352 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !(
#line 5334 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 5336 "../../../gcc/config/s390/s390.md"
( reload_completed)))
            return NULL;
          return gen_split_353 (insn, operands);

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2128 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2130 "../../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_50 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2128 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2130 "../../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_51 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GT:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2150 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2152 "../../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_52 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2150 "../../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3) && 
#line 2152 "../../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_53 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case GTU:
          switch (GET_MODE (operands[0]))
            {
            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) == 0
                  && (
#line 2184 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2186 "../../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_54 (insn, operands);
              break;

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) == 0
                  && (
#line 2184 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 2186 "../../../gcc/config/s390/vector.md"
( can_create_pseudo_p ())))
                return gen_split_55 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7282 "../../../gcc/config/s390/s390.md"
(reload_completed) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_363 (insn, operands);

        case 1:
          if (!
#line 7282 "../../../gcc/config/s390/s390.md"
(reload_completed))
            return NULL;
          return gen_split_364 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 792 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return NULL;
          return gen_split_375 (insn, operands);

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return NULL;
          return gen_split_376 (insn, operands);

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return NULL;
          return gen_split_377 (insn, operands);

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_HImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return NULL;
      return gen_split_392 (insn, operands);

    default:
      return NULL;
    }
}
