/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2DFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2DFmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2DFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2DFmode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern8 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern8 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern8 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern8 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern8 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern8 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern8 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern8 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern8 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern8 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern8 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern8 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern8 (x1, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern8 (x1, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!cc_reg_operand (operands[2], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !s390_comparison (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !s390_comparison (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern19 (x1, 
E_V4SFmode); /* [-1, 0] */

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 1;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 2;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != i1
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XVECEXP (x7, 0, 0);
  operands[1] = x8;
  x9 = XVECEXP (x7, 0, 1);
  operands[2] = x9;
  x10 = XVECEXP (x7, 0, 2);
  operands[3] = x10;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 33
      || GET_MODE (x11) != E_CCmode)
    return -1;
  x12 = XEXP (x4, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  switch (GET_CODE (x13))
    {
    case GT:
    case LE:
      operands[5] = x13;
      if (!s390_brx_operator (operands[5], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != PLUS)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != SUBREG)
        return -1;
      x16 = XEXP (x13, 1);
      if (GET_CODE (x16) != SUBREG)
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x18 = XEXP (x14, 0);
      operands[1] = x18;
      x19 = XEXP (x15, 0);
      operands[2] = x19;
      x20 = XEXP (x7, 0);
      operands[3] = x20;
      x21 = XEXP (x9, 0);
      operands[4] = x21;
      x22 = XEXP (x16, 0);
      if (!rtx_equal_p (x22, operands[2]))
        return -1;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      x24 = XEXP (x17, 0);
      if (!rtx_equal_p (x24, operands[2]))
        return -1;
      switch (SUBREG_BYTE (x15))
        {
        case 0:
          if (maybe_ne (SUBREG_BYTE (x17), 0))
            return -1;
          switch (SUBREG_BYTE (x16))
            {
            case 8:
              return pattern76 (x1, 
E_DImode, 
E_TImode); /* [-1, 0] */

            case 4:
              if (pattern76 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 1;

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x15) != E_SImode
              || maybe_ne (SUBREG_BYTE (x16), 12)
              || GET_MODE (x16) != E_SImode
              || maybe_ne (SUBREG_BYTE (x17), 4)
              || GET_MODE (x17) != E_SImode
              || GET_MODE (x14) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_TImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || GET_MODE (x8) != E_SImode
              || !scratch_operand (operands[4], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case NE:
      x16 = XEXP (x13, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x17 = XEXP (x8, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x14 = XEXP (x13, 0);
      operands[1] = x14;
      x20 = XEXP (x7, 0);
      operands[2] = x20;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      x23 = XEXP (x8, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern77 (x8, 
E_SImode) != 0)
            return -1;
          return 3;

        case E_DImode:
          if (pattern77 (x8, 
E_DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return pattern145 (x8, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern145 (x8, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CLOBBER:
      res = pattern146 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern157 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !nonimmediate_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !nonimmediate_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !nonimmediate_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !nonimmediate_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !nonimmediate_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !nonimmediate_operand (operands[1], E_V1TImode))
        return -1;
      return 5;

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !nonimmediate_operand (operands[1], E_V1TFmode))
        return -1;
      return 6;

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !nonimmediate_operand (operands[1], E_TImode))
        return -1;
      return 7;

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !nonimmediate_operand (operands[1], E_TFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  switch (GET_MODE (operands[4]))
    {
    case E_DImode:
      if (!scratch_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern211 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern221 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !loc_operand (operands[3], i1)
      || !loc_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern267 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern275 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 13);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1185; /* vec_widen_umult_even_v1qi */

    case 1:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1186; /* vec_widen_umult_even_v2qi */

    case 2:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1187; /* vec_widen_umult_even_v4qi */

    case 3:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1188; /* vec_widen_umult_even_v8qi */

    case 4:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1189; /* vec_widen_umult_even_v16qi */

    case 5:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1190; /* vec_widen_umult_even_v1hi */

    case 6:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1191; /* vec_widen_umult_even_v2hi */

    case 7:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1192; /* vec_widen_umult_even_v4hi */

    case 8:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1193; /* vec_widen_umult_even_v8hi */

    case 9:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* vec_widen_umult_even_v1si */

    case 10:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* vec_widen_umult_even_v2si */

    case 11:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1196; /* vec_widen_umult_even_v4si */

    case 12:
      if (!
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1197; /* vec_widen_umult_even_v1di */

    case 13:
      if (!(
#line 1727 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1198; /* vec_widen_umult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 63:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode)
          || !
#line 201 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[2]) < 7))
        return -1;
      return 16; /* vlbb */

    case 65:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 227 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 17; /* *vlrlrv16qi */

    case 66:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 266 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 18; /* vec_packv8hi */

        case 1:
          if (!
#line 266 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 19; /* vec_packv4si */

        case 2:
          if (!
#line 266 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 20; /* vec_packv2di */

        default:
          return -1;
        }

    case 67:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 279 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 21; /* vec_packsv8hi */

        case 1:
          if (!
#line 279 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 22; /* vec_packsv4si */

        case 2:
          if (!
#line 279 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 23; /* vec_packsv2di */

        default:
          return -1;
        }

    case 70:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 325 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 27; /* vec_packsuv8hi */

        case 1:
          if (!
#line 325 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 28; /* vec_packsuv4si */

        case 2:
          if (!
#line 325 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 29; /* vec_packsuv2di */

        default:
          return -1;
        }

    case 75:
      return recog_2 (x1, insn, pnum_clobbers);

    case 76:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 593 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 92; /* *vstrlrv16qi */

    case 77:
      if (pattern18 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 609 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 93; /* vbpermv16qi */

    case 82:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 665 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 110; /* vaccb_v16qi */

        case 1:
          if (!
#line 665 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 111; /* vacch_v8hi */

        case 2:
          if (!
#line 665 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 112; /* vaccf_v4si */

        case 3:
          if (!
#line 665 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 113; /* vaccg_v2di */

        case 4:
          if (!
#line 665 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vaccq_v1ti */

        case 5:
          if (!
#line 665 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vaccq_ti */

        default:
          return -1;
        }

    case 85:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 717 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 127; /* vec_avgv16qi */

        case 1:
          if (!
#line 717 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 128; /* vec_avgv8hi */

        case 2:
          if (!
#line 717 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 129; /* vec_avgv4si */

        case 3:
          if (!
#line 717 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 130; /* vec_avgv2di */

        case 4:
          if (!(
#line 717 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 131; /* vec_avgv1ti */

        case 5:
          if (!(
#line 717 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 132; /* vec_avgti */

        default:
          return -1;
        }

    case 86:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 729 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 133; /* vec_avguv16qi */

        case 1:
          if (!
#line 729 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 134; /* vec_avguv8hi */

        case 2:
          if (!
#line 729 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 135; /* vec_avguv4si */

        case 3:
          if (!
#line 729 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_avguv2di */

        case 4:
          if (!(
#line 729 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 137; /* vec_avguv1ti */

        case 5:
          if (!(
#line 729 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 138; /* vec_avguti */

        default:
          return -1;
        }

    case 87:
      if (pattern21 (x1, 
E_V4SImode) != 0
          || !
#line 741 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_checksum */

    case 88:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x2, 
E_V16QImode) != 0
              || !
#line 850 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_gfmsumv16qi */

        case E_V8HImode:
          if (pattern19 (x2, 
E_V8HImode) != 0
              || !
#line 850 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_gfmsumv8hi */

        case E_V4SImode:
          if (pattern19 (x2, 
E_V4SImode) != 0
              || !
#line 850 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_gfmsumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern18 (x1, 
E_V2DImode, 
E_V16QImode) != 0
          || !
#line 859 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 143; /* vec_gfmsum_128 */

    case 47:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 989 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 182; /* vec_smulhv16qi */

        case 1:
          if (!
#line 989 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 183; /* vec_smulhv8hi */

        case 2:
          if (!
#line 989 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 184; /* vec_smulhv4si */

        case 3:
          if (!(
#line 989 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 185; /* vec_smulhv2di */

        case 4:
          if (!(
#line 989 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 186; /* vec_smulhv1ti */

        case 5:
          if (!(
#line 989 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 187; /* vec_smulhti */

        default:
          return -1;
        }

    case 48:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 999 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 188; /* vec_umulhv16qi */

        case 1:
          if (!
#line 999 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 189; /* vec_umulhv8hi */

        case 2:
          if (!
#line 999 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 190; /* vec_umulhv4si */

        case 3:
          if (!(
#line 999 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 191; /* vec_umulhv2di */

        case 4:
          if (!(
#line 999 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 192; /* vec_umulhv1ti */

        case 5:
          if (!(
#line 999 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 193; /* vec_umulhti */

        default:
          return -1;
        }

    case 97:
      return recog_6 (x1, insn, pnum_clobbers);

    case 102:
      return recog_5 (x1, insn, pnum_clobbers);

    case 103:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vec_srabv16qi */

        case 1:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vec_srabv8hi */

        case 2:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 299; /* vec_srabv4si */

        case 3:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 300; /* vec_srabv2di */

        case 4:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 301; /* vec_srabv1ti */

        case 5:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 302; /* vec_srabti */

        case 6:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 303; /* vec_srabv4sf */

        case 7:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 304; /* vec_srabv2df */

        case 8:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 305; /* vec_srabv1tf */

        case 9:
          if (!
#line 1130 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 306; /* vec_srabtf */

        default:
          return -1;
        }

    case 104:
      return recog_4 (x1, insn, pnum_clobbers);

    case 106:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 1167 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 337; /* vscbib_v16qi */

        case 1:
          if (!
#line 1167 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 338; /* vscbih_v8hi */

        case 2:
          if (!
#line 1167 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 339; /* vscbif_v4si */

        case 3:
          if (!
#line 1167 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 340; /* vscbig_v2di */

        case 4:
          if (!
#line 1167 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 341; /* vscbiq_v1ti */

        case 5:
          if (!
#line 1167 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 342; /* vscbiq_ti */

        default:
          return -1;
        }

    case 94:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1215 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 345; /* vec_sum_u128v4si */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 1215 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 346; /* vec_sum_u128v2di */

        default:
          return -1;
        }

    case 109:
      return recog_3 (x1, insn, pnum_clobbers);

    case 130:
      return recog_12 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern26 (x1, 
3, 
2, 
1, 
0) != 0
          || !
#line 2224 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 501; /* vclfnhs_v8hi */

    case 139:
      if (pattern26 (x1, 
7, 
6, 
5, 
4) != 0
          || !
#line 2235 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 502; /* vclfnls_v8hi */

    case 141:
      if (pattern27 (x1) != 0
          || !
#line 2254 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 504; /* vcfn_v8hi */

    case 142:
      if (pattern27 (x1) != 0
          || !
#line 2263 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 505; /* vcnf_v8hi */

    case 93:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1232 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 768; /* *vec_sum2v8hi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1232 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 769; /* *vec_sum2v4si */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 1242 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 770; /* *vec_sum4v16qi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1242 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 771; /* *vec_sum4v8hi */

        default:
          return -1;
        }

    case 105:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1087; /* *vec_srbv16qi */

        case 1:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1088; /* *vec_srbv8hi */

        case 2:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1089; /* *vec_srbv4si */

        case 3:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1090; /* *vec_srbv2di */

        case 4:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1091; /* *vec_srbv1ti */

        case 5:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1092; /* *vec_srbti */

        case 6:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1093; /* *vec_srbv4sf */

        case 7:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1094; /* *vec_srbv2df */

        case 8:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1095; /* *vec_srbv1tf */

        case 9:
          if (!
#line 1578 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1096; /* *vec_srbtf */

        default:
          return -1;
        }

    case 98:
      return recog_13 (x1, insn, pnum_clobbers);

    case 50:
      return recog_11 (x1, insn, pnum_clobbers);

    case 51:
      return recog_10 (x1, insn, pnum_clobbers);

    case 52:
      return recog_9 (x1, insn, pnum_clobbers);

    case 53:
      return recog_8 (x1, insn, pnum_clobbers);

    case 64:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 2427 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1406; /* vllv16qi */

    case 3:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 3731 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 1891; /* *mvcrl */

    case 36:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 1917; /* *sethighpartsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          if (
#line 4257 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 1918; /* *sethighpartdi_64 */
            }
          if (!
#line 4267 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1919; /* *sethighpartdi_31 */

        default:
          return -1;
        }

    case 38:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4943 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
        return -1;
      return 2006; /* bdepg */

    case 39:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4956 "../../../gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
        return -1;
      return 2007; /* bextg */

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 11087 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2581; /* *tls_load_64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 11097 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2582; /* *tls_load_31 */

        default:
          return -1;
        }

    case 34:
      if (pattern25 (x1, 
E_CCZmode) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2625; /* stack_protect_testdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2626; /* stack_protect_testsi */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2627; /* stack_tiedi */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2628; /* stack_tiesi */

        default:
          return -1;
        }

    case 46:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!address_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 12547 "../../../gcc/config/s390/s390.md"
(TARGET_Z13))
        return -1;
      *pnum_clobbers = 1;
      return 2660; /* lcbb */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_VOIDmode))
    {
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!const_int_operand (x5, E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 16L:
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x5;
      if (!
#line 4894 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (16, INTVAL (operands[1]), 64)
   && INTVAL (operands[1]) >= 0
   && INTVAL (operands[1]) < BITS_PER_WORD
   && INTVAL (operands[1]) % 16 == 0))
        return -1;
      return 2003; /* *insvdi_reg_imm */

    case 32L:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          if (!
#line 4918 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2004; /* *insv_h_di_reg_extimm */

        case 32L:
          if (!
#line 4929 "../../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2005; /* *insv_l_di_reg_extimm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2638 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1510; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5326 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2036; /* *zero_extendqihi2_64 */
          if (!
#line 5334 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2037; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2694 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1513; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2705 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1514; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2741 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1517; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2751 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1518; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2787 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1521; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2797 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2298; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2300; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 2299; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 2301; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_22 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_23 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 816; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 817; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 818; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 819; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 820; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 821; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 822; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 823; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 824; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 825; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 826; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 827; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 828; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 829; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 830; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 831; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 832; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 833; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 834; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 835; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 836; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1276 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 837; /* iorti3 */
          break;

        case 22:
          if (
#line 8363 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2364; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8500 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2369; /* *iorhi3_zarch */
            }
          if (
#line 8516 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2370; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8543 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2371; /* *iorqi3_zarch */
            }
          if (
#line 8561 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2372; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4785 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1996; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8444 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2367; /* *iorsi3_zarch */
        }
      if (!
#line 8472 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2368; /* *iorsi3_esa */

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1577; /* *vevalv1qi_iorior */

        case 1:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1586; /* *vevalv2qi_iorior */

        case 2:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1595; /* *vevalv4qi_iorior */

        case 3:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1604; /* *vevalv8qi_iorior */

        case 4:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1613; /* *vevalv16qi_iorior */

        case 5:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1622; /* *vevalv1hi_iorior */

        case 6:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1631; /* *vevalv2hi_iorior */

        case 7:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1640; /* *vevalv4hi_iorior */

        case 8:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1649; /* *vevalv8hi_iorior */

        case 9:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1658; /* *vevalv1si_iorior */

        case 10:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1667; /* *vevalv2si_iorior */

        case 11:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1676; /* *vevalv4si_iorior */

        case 12:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1685; /* *vevalv1di_iorior */

        case 13:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1694; /* *vevalv2di_iorior */

        case 14:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1703; /* *vevalv1ti_iorior */

        case 15:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1712; /* *vevalti_iorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1578; /* *vevalv1qi_iorxor */

        case 1:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1587; /* *vevalv2qi_iorxor */

        case 2:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1596; /* *vevalv4qi_iorxor */

        case 3:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1605; /* *vevalv8qi_iorxor */

        case 4:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1614; /* *vevalv16qi_iorxor */

        case 5:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1623; /* *vevalv1hi_iorxor */

        case 6:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1632; /* *vevalv2hi_iorxor */

        case 7:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1641; /* *vevalv4hi_iorxor */

        case 8:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1650; /* *vevalv8hi_iorxor */

        case 9:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1659; /* *vevalv1si_iorxor */

        case 10:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1668; /* *vevalv2si_iorxor */

        case 11:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1677; /* *vevalv4si_iorxor */

        case 12:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1686; /* *vevalv1di_iorxor */

        case 13:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1695; /* *vevalv2di_iorxor */

        case 14:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1704; /* *vevalv1ti_iorxor */

        case 15:
          if (!
#line 3400 "../../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1713; /* *vevalti_iorxor */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern31 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4746 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1988; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4746 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1990; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern132 (x3, 
DIV) != 0
                  || pattern203 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7663 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2329; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7681 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2330; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern269 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7742 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2331; /* udivmodtidi3 */

                    case 32L:
                      if (pattern269 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7862 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 2333; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7801 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 2332; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern132 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern203 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9620 "../../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4765 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1992; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4765 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1994; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern167 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2208 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 496; /* *vec_extract_bswap_elemv8hi */

        case E_SImode:
          if (pattern167 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2208 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 497; /* *vec_extract_bswap_elemv4si */

        case E_SFmode:
          if (pattern167 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2208 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 498; /* *vec_extract_bswap_elemv4sf */

        case E_DImode:
          if (pattern167 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2208 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 499; /* *vec_extract_bswap_elemv2di */

        case E_DFmode:
          if (pattern167 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2208 "../../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 500; /* *vec_extract_bswap_elemv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!memory_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 3350 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1568; /* *vstbrv8hi */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 3350 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1569; /* *vstbrv4si */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3350 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1570; /* *vstbrv2di */

        case E_V1TImode:
          if (!memory_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 3350 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1571; /* *vstbrv1ti */

        case E_TImode:
          if (!memory_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 3350 "../../../gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1572; /* *vstbrti */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2631; /* bswapdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 2632; /* bswapsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2633; /* bswaphi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern168 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 599 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 619; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern168 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 599 "../../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 620; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern108 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2416 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1404; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern108 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2416 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1405; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern33 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2604 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1492; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2604 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1493; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2604 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1494; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern33 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2616 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1495; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2616 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1496; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2616 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1497; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern33 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2628 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1498; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2628 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1499; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2628 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1500; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != ABS
          || !register_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !(
#line 9309 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2445; /* *absdi2_cc */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 9309 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2446; /* *abssi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 9320 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2447; /* *absdi2_cconly */

        case 1:
          if (!
#line 9320 "../../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2448; /* *abssi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern121 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 8146 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2355; /* *andhi3_zarch */
      if (!
#line 8163 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2356; /* *andhi3_esa */

    case E_QImode:
      if (pattern121 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 8191 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2357; /* *andqi3_zarch */
      if (!
#line 8208 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2358; /* *andqi3_esa */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case STRICT_LOW_PART:
      if (pattern90 (x1) != 0
          || !subreg_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1856; /* movstricthi */

    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 3106 "../../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1873; /* *mvc */

    case ZERO_EXTRACT:
      if (pattern90 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[3], E_DImode)
              || !(
#line 4479 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1951; /* *insvdi_clobbercc */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || !
#line 4479 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
            return -1;
          return 1953; /* *insvsi_clobbercc */

        default:
          return -1;
        }

    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1)
        return -1;
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 10412 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2544; /* indirect_jump_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !(
#line 10412 "../../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2545; /* indirect_jump_via_thunksi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern193 (x6))
    {
    case 0:
      if (!(
#line 4313 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1921; /* *extzvdi_clobbercc */

    case 1:
      if (!
#line 4313 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1923; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x9 = XEXP (x6, 2);
              operands[5] = x9;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern278 (x4, 
E_DImode) != 0
                      || !
#line 4345 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1927; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern278 (x4, 
E_SImode) != 0
                      || !
#line 4345 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1929; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern263 (x4, 
E_DImode) != 0
                      || !(
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1955; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern263 (x4, 
E_SImode) != 0
                      || !
#line 4495 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  return 1957; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern264 (x4, 
E_DImode) != 0
                      || !(
#line 4549 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1961; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern264 (x4, 
E_SImode) != 0
                      || !
#line 4549 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  return 1963; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern265 (x4, 
E_DImode) != 0
                      || !(
#line 4564 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1965; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern265 (x4, 
E_SImode) != 0
                      || !
#line 4564 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  return 1967; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == LSHIFTRT
                      && GET_MODE (x7) == E_DImode
                      && pattern228 (x4, 
E_SImode) == 0
                      && const_int_operand (operands[2], E_SImode))
                    {
                      x10 = XEXP (x7, 0);
                      operands[3] = x10;
                      if (register_operand (operands[3], E_DImode))
                        {
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (nonzero_shift_count_operand (operands[4], E_DImode)
                              && 
#line 4581 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
                            return 1969; /* *risbg_sidi_ior_and_lshiftrt */
                        }
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern250 (x4, 
E_DImode) != 0
                      || !(
#line 4678 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1974; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern250 (x4, 
E_SImode) != 0
                      || !
#line 4678 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  return 1976; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (!
#line 4693 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1978; /* *rosbg_di_rotl */

        case 2:
          if (!(
#line 4708 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1980; /* *rosbg_di_srl_bitmask */

        case 3:
          if (!
#line 4708 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1982; /* *rosbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4728 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1984; /* *rosbg_di_sll_bitmask */

        case 5:
          if (!
#line 4728 "../../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1986; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern95 (x4))
            {
            case 0:
              if (!(
#line 4746 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1988; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4746 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1990; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x13) != E_TImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != CLZ
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_TImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_DImode)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != LSHIFTRT)
            return -1;
          x16 = XEXP (x11, 1);
          if (GET_CODE (x16) != SUBREG
              || maybe_ne (SUBREG_BYTE (x16), 4)
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != CLZ
              || GET_MODE (x17) != E_DImode
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x19 = XEXP (x11, 0);
          operands[2] = x19;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x20 = XEXP (x17, 0);
          if (!rtx_equal_p (x20, operands[1])
              || !
#line 9620 "../../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
            return -1;
          return 2500; /* clztidi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4765 "../../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1992; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4765 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1994; /* *rosbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4785 "../../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1996; /* *rosbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8668 "../../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2399; /* *oc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8363 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2364; /* *iordi3 */

        case 1:
          if (
#line 8444 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2367; /* *iorsi3_zarch */
          if (!
#line 8472 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2368; /* *iorsi3_esa */

        case 2:
          if (
#line 8500 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2369; /* *iorhi3_zarch */
          if (!
#line 8516 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2370; /* *iorhi3_esa */

        case 3:
          if (
#line 8543 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2371; /* *iorqi3_zarch */
          if (!
#line 8561 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2372; /* *iorqi3_esa */

        default:
          return -1;
        }

    case NOT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern241 (x4, 
E_DImode) != 0
                  || !(
#line 8605 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2382; /* *orcdi */

            case E_SImode:
              if (pattern241 (x4, 
E_SImode) != 0
                  || !
#line 8605 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2384; /* *orcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern216 (x4))
            {
            case 0:
              if (!(
#line 8645 "../../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2394; /* *nanddi */

            case 1:
              if (!
#line 8645 "../../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2396; /* *nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern44 (x2, 
10, 
1, 
UNSPEC_VOLATILE) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2595; /* atomic_fetch_anddi_iaf */

        case 1:
          if (!
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2599; /* atomic_fetch_andsi_iaf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2596; /* atomic_fetch_ordi_iaf */

        case 1:
          if (!
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2600; /* atomic_fetch_orsi_iaf */

        default:
          return -1;
        }

    case XOR:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2597; /* atomic_fetch_xordi_iaf */

        case 1:
          if (!
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* atomic_fetch_xorsi_iaf */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2598; /* atomic_fetch_adddi_iaf */

        case 1:
          if (!
#line 11424 "../../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* atomic_fetch_addsi_iaf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (pattern101 (x3))
        {
        case 0:
          if (const0_operand (operands[1], E_V1QImode)
              && all_ones_operand (operands[2], E_V1QImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_56 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1QImode)
              || !const0_operand (operands[2], E_V1QImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_75 (insn, operands);

        case 1:
          if (const0_operand (operands[1], E_V2QImode)
              && all_ones_operand (operands[2], E_V2QImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_57 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2QImode)
              || !const0_operand (operands[2], E_V2QImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_76 (insn, operands);

        case 2:
          if (const0_operand (operands[1], E_V4QImode)
              && all_ones_operand (operands[2], E_V4QImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_58 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4QImode)
              || !const0_operand (operands[2], E_V4QImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_77 (insn, operands);

        case 3:
          if (const0_operand (operands[1], E_V8QImode)
              && all_ones_operand (operands[2], E_V8QImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_59 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8QImode)
              || !const0_operand (operands[2], E_V8QImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_78 (insn, operands);

        case 4:
          if (const0_operand (operands[1], E_V16QImode)
              && all_ones_operand (operands[2], E_V16QImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_60 (insn, operands);
          if (!all_ones_operand (operands[1], E_V16QImode)
              || !const0_operand (operands[2], E_V16QImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_79 (insn, operands);

        case 5:
          if (const0_operand (operands[1], E_V1HImode)
              && all_ones_operand (operands[2], E_V1HImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_61 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1HImode)
              || !const0_operand (operands[2], E_V1HImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_80 (insn, operands);

        case 6:
          if (const0_operand (operands[1], E_V2HImode)
              && all_ones_operand (operands[2], E_V2HImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_62 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2HImode)
              || !const0_operand (operands[2], E_V2HImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_81 (insn, operands);

        case 7:
          if (const0_operand (operands[1], E_V4HImode)
              && all_ones_operand (operands[2], E_V4HImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_63 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4HImode)
              || !const0_operand (operands[2], E_V4HImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_82 (insn, operands);

        case 8:
          if (const0_operand (operands[1], E_V8HImode)
              && all_ones_operand (operands[2], E_V8HImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_64 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8HImode)
              || !const0_operand (operands[2], E_V8HImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_83 (insn, operands);

        case 9:
          if (const0_operand (operands[1], E_V1SImode)
              && all_ones_operand (operands[2], E_V1SImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_65 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SImode)
              || !const0_operand (operands[2], E_V1SImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_84 (insn, operands);

        case 10:
          if (const0_operand (operands[1], E_V2SImode)
              && all_ones_operand (operands[2], E_V2SImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_66 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SImode)
              || !const0_operand (operands[2], E_V2SImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_85 (insn, operands);

        case 11:
          if (const0_operand (operands[1], E_V4SImode)
              && all_ones_operand (operands[2], E_V4SImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_67 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_86 (insn, operands);

        case 12:
          if (const0_operand (operands[1], E_V1DImode)
              && all_ones_operand (operands[2], E_V1DImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_68 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DImode)
              || !const0_operand (operands[2], E_V1DImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_87 (insn, operands);

        case 13:
          if (const0_operand (operands[1], E_V2DImode)
              && all_ones_operand (operands[2], E_V2DImode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_69 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_88 (insn, operands);

        case 14:
          if (const0_operand (operands[1], E_V1SFmode)
              && all_ones_operand (operands[2], E_V1SFmode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_70 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SFmode)
              || !const0_operand (operands[2], E_V1SFmode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_89 (insn, operands);

        case 15:
          if (const0_operand (operands[1], E_V2SFmode)
              && all_ones_operand (operands[2], E_V2SFmode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_71 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SFmode)
              || !const0_operand (operands[2], E_V2SFmode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_90 (insn, operands);

        case 16:
          if (const0_operand (operands[1], E_V4SFmode)
              && all_ones_operand (operands[2], E_V4SFmode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_72 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SFmode)
              || !const0_operand (operands[2], E_V4SFmode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_91 (insn, operands);

        case 17:
          if (const0_operand (operands[1], E_V1DFmode)
              && all_ones_operand (operands[2], E_V1DFmode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_73 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DFmode)
              || !const0_operand (operands[2], E_V1DFmode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_92 (insn, operands);

        case 18:
          if (const0_operand (operands[1], E_V2DFmode)
              && all_ones_operand (operands[2], E_V2DFmode)
              && 
#line 2498 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_74 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DFmode)
              || !const0_operand (operands[2], E_V2DFmode)
              || !
#line 2512 "../../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      return split_2 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_7 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_6 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case VEC_SELECT:
              if (GET_MODE (x4) != E_V8HImode)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != PARALLEL
                  || XVECLEN (x5, 0) != 8)
                return NULL;
              x6 = XVECEXP (x5, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return NULL;
              x7 = XVECEXP (x5, 0, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
                return NULL;
              x8 = XVECEXP (x5, 0, 2);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
                return NULL;
              x9 = XVECEXP (x5, 0, 3);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x10 = XVECEXP (x5, 0, 4);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x11 = XVECEXP (x5, 0, 5);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return NULL;
              x12 = XVECEXP (x5, 0, 6);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x13 = XVECEXP (x5, 0, 7);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != CLOBBER
                  || pattern266 (x1) != 0
                  || !(
#line 1038 "../../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1043 "../../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
                return NULL;
              return gen_split_45 (insn, operands);

            case IF_THEN_ELSE:
              x15 = XEXP (x4, 0);
              if (!s390_brx_operator (x15, E_VOIDmode))
                return NULL;
              operands[6] = x15;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != PLUS)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != LABEL_REF)
                return NULL;
              x17 = XEXP (x4, 2);
              if (GET_CODE (x17) != PC)
                return NULL;
              x18 = XEXP (x2, 0);
              if (GET_CODE (x18) != PC)
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != SET)
                return NULL;
              x19 = XEXP (x14, 1);
              if (GET_CODE (x19) != PLUS)
                return NULL;
              switch (pattern230 (x1))
                {
                case 0:
                  if (!(
#line 10026 "../../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress) && 
#line 768 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return NULL;
                  return gen_split_385 (insn, operands);

                case 1:
                  if (!
#line 10026 "../../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress))
                    return NULL;
                  return gen_split_386 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x20 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x20) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SUBREG:
            case MEM:
              if (pattern74 (x1) != 0)
                return NULL;
              switch (pattern196 (x1))
                {
                case 0:
                  if (!
#line 3598 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_321 (insn, operands);

                case 1:
                  if (!
#line 3610 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 2:
                  if (!
#line 3624 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_323 (insn, operands);

                case 3:
                  if (!
#line 3638 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_324 (insn, operands);

                default:
                  return NULL;
                }

            case COMPARE:
              if (pattern73 (x1) != 0)
                return NULL;
              switch (pattern196 (x1))
                {
                case 0:
                  if (!
#line 4048 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!
#line 4061 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_331 (insn, operands);

                case 2:
                  if (!
#line 4076 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 3:
                  if (!
#line 4091 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_333 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern78 (x1))
                {
                case 0:
                  if (!(
#line 10064 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10073 "../../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_387 (insn, operands);

                case 1:
                  if (!(
#line 10150 "../../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 10159 "../../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_389 (insn, operands);

                case 2:
                  if (!(
#line 10107 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10116 "../../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_388 (insn, operands);

                case 3:
                  if (!
#line 10215 "../../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2]))))
                    return NULL;
                  return gen_split_390 (insn, operands);

                case 4:
                  if (!(
#line 10248 "../../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10257 "../../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2])))))
                    return NULL;
                  return gen_split_391 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != USE)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0)
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x20 = XVECEXP (x1, 0, 3);
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != SCRATCH)
                return NULL;
              x22 = XEXP (x3, 0);
              operands[2] = x22;
              if (!immediate_operand (operands[2], E_VOIDmode)
                  || !
#line 3854 "../../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_326 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_VOIDmode))
                return NULL;
              x22 = XEXP (x3, 0);
              switch (GET_CODE (x22))
                {
                case SUBREG:
                case MEM:
                  operands[2] = x22;
                  if (!memory_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x21 = XEXP (x20, 0);
                  if (GET_CODE (x21) != SCRATCH
                      || !
#line 3868 "../../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_327 (insn, operands);

                case CONST:
                  if (GET_MODE (x22) != E_BLKmode)
                    return NULL;
                  x23 = XEXP (x22, 0);
                  if (GET_CODE (x23) != UNSPEC
                      || XVECLEN (x23, 0) != 1
                      || XINT (x23, 1) != 17
                      || GET_MODE (x23) != E_BLKmode)
                    return NULL;
                  x24 = XVECEXP (x23, 0, 0);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x21 = XEXP (x20, 0);
                  switch (GET_CODE (x21))
                    {
                    case SCRATCH:
                      if (!
#line 3884 "../../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                        return NULL;
                      return gen_split_328 (insn, operands);

                    case REG:
                    case SUBREG:
                      operands[2] = x21;
                      if (!register_operand (operands[2], E_VOIDmode)
                          || !
#line 3900 "../../../gcc/config/s390/s390.md"
(reload_completed))
                        return NULL;
                      return gen_split_329 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
